// AnalogCtrlCtl.cpp : Implementation of the CAnalogCtrlCtrl ActiveX Control class.

#include "stdafx.h"
#include "AnalogCtrl.h"
#include "AnalogCtrlCtl.h"
#include "AnalogCtrlPpg.h"
#include <MATH.H>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CAnalogCtrlCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CAnalogCtrlCtrl, COleControl)
	//{{AFX_MSG_MAP(CAnalogCtrlCtrl)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
	ON_MESSAGE( WM_CALIBRATION_END, OnCalibrationEnd )
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CAnalogCtrlCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CAnalogCtrlCtrl)
	DISP_PROPERTY_NOTIFY(CAnalogCtrlCtrl, "emptyColor", m_emptyColor, OnEmptyColorChanged, VT_COLOR)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "AnalogColor", GetGetAnalogColorSelect, SetGetAnalogColorSelect, VT_I2)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "ApdReport", GetApdReportSelect, SetApdReportSelect, VT_BOOL)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "AnalogRealId", GetAiRealID, SetAiRealID, VT_I2)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "Interlock", GetInterlockUsingSelect, SetInterlockUsingSelect, VT_BOOL)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "EdcReport", GetEdcReportSelect, SetEdcReportSelect, VT_BOOL)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "AnalogName", GetAnalogUnitName, SetAnalogUnitName, VT_BSTR)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "Analogcalculation", GetAnalogcalculation, SetNotSupported, VT_I4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "AlarmStateSetting", GetAlarmStateSetting, SetAlarmStateSetting, VT_BSTR)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "AdcMinVal", GetAdcMinVal, SetAdcMinVal, VT_I2)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "AdcMaxVal", GetAdcMaxVal, SetAdcMaxVal, VT_I2)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "RealMinVal", GetRealMinVal, SetRealMinVal, VT_R4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "RealMaxVal", GetRealMaxVal, SetRealMaxVal, VT_R4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "AnalogCalDisplay", GetAnalogCalDisplay, SetAnalogCalDisplay, VT_R4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "PermitAccess", GetPermitAccess, SetPermitAccess, VT_BOOL)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "CurAdcVal", GetCurAdcVal, SetCurAdcVal, VT_I4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "CalScale", GetCalScale, SetCalScale, VT_I2)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "InitParameter", GetInitParameter, SetInitParameter, VT_I2)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "ApdReportUnitNo", GetApdReportUnitNo, SetApdReportUnitNo, VT_I2)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "Profileini", GetProfileini, SetProfileini, VT_I2)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "AnalogOcxCtlId", GetAnalogOcxCtlId, SetAnalogOcxCtlId, VT_I2)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "InitParameterSet", GetInitParameterSet, SetInitParameterSet, VT_I2)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "Accumulate", GetAccumulate, SetAccumulate, VT_BOOL)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "PrecentInterlock", GetPercentInterlock, SetPercentInterlock, VT_BOOL)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "SetPointInterlockValue", GetSetPointInterlockValue, SetSetPointInterlockValue, VT_R4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "PointInterlockValue", GetPointInterlockValue, SetPointInterlockValue, VT_R4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "FilterGain", GetFilterGain, SetNotSupported, VT_R4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "LowLimitValue", GetLowLimitValue, SetLowLimitValue, VT_R4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "SetLoWarningValue", GetSetLoWarningValue, SetSetLoWarningValue, VT_R4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "UpLimitValue", GetUpLimitValue, SetUpLimitValue, VT_R4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "UpWarningValue", GetUpWarningValue, SetUpWarningValue, VT_R4)
	DISP_PROPERTY_EX(CAnalogCtrlCtrl, "KindOfUnit", GetKindOfUnit, SetKindOfUnit, VT_BSTR)
	DISP_FUNCTION(CAnalogCtrlCtrl, "SetColorCstSlot", SetColorCstSlot, VT_EMPTY, VTS_COLOR)
	DISP_FUNCTION(CAnalogCtrlCtrl, "GetCalculation", GetCalculation, VT_R4, VTS_NONE)
	DISP_FUNCTION(CAnalogCtrlCtrl, "SetAlarmEnable", SetAlarmEnable, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CAnalogCtrlCtrl, "SetAlarmState", SetAlarmState, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CAnalogCtrlCtrl, "SetAlarmRelease", SetAlarmRelease, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CAnalogCtrlCtrl, "GetApdReportID", GetApdReportID, VT_I2, VTS_NONE)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CAnalogCtrlCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CAnalogCtrlCtrl, COleControl)
	//{{AFX_EVENT_MAP(CAnalogCtrlCtrl)
	EVENT_STOCK_CLICK()
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CAnalogCtrlCtrl, 1)
	PROPPAGEID(CAnalogCtrlPropPage::guid)
END_PROPPAGEIDS(CAnalogCtrlCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CAnalogCtrlCtrl, "ANALOGCTRL.AnalogCtrlCtrl.1",
	0x81b0111d, 0x904e, 0x4f07, 0x81, 0xea, 0x4, 0x4f, 0x54, 0x32, 0x72, 0x51)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CAnalogCtrlCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DAnalogCtrl =
		{ 0x406bcca5, 0x988b, 0x4dcf, { 0xa0, 0xfc, 0x1f, 0xa6, 0x36, 0x34, 0xf4, 0x28 } };
const IID BASED_CODE IID_DAnalogCtrlEvents =
		{ 0xbb04a9cc, 0x10a2, 0x4a7c, { 0xac, 0x4d, 0xde, 0x61, 0xe0, 0x95, 0x24, 0xc7 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwAnalogCtrlOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CAnalogCtrlCtrl, IDS_ANALOGCTRL, _dwAnalogCtrlOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlCtrl::CAnalogCtrlCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CAnalogCtrlCtrl

BOOL CAnalogCtrlCtrl::CAnalogCtrlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_ANALOGCTRL,
			IDB_ANALOGCTRL,
			afxRegApartmentThreading,
			_dwAnalogCtrlOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlCtrl::CAnalogCtrlCtrl - Constructor

CAnalogCtrlCtrl::CAnalogCtrlCtrl()
{
	InitializeIIDs(&IID_DAnalogCtrl, &IID_DAnalogCtrlEvents);
	m_pIniData = new CIniData;
	m_emptyColor = RGB(190, 255, 255);
	m_sAiValue = "000.000";
	m_sAiUnitName = "";
	m_nType		= 0;
	m_nCurType	= 0;
	m_nFontSize	= 14;
	m_nOldType	= 0;
	m_nAiRealID = 0;
	m_nOcxCtrlID = 0;
	m_nCurAdc	= 0;
	m_nAnalogInput	= 0;
	m_nOldAdc		= 0;
	m_bApdReport = FALSE;
	m_bEdcReport = FALSE;
	m_bInterlockUsing = FALSE;
	m_bAccumulate	= FALSE;
	m_bPercentInterlock = FALSE;
	m_bInitParameter = FALSE;
	m_bFirstVal		 = FALSE;
	m_fCalcuAnalog	 = 0.0f;
	m_bRun			 = FALSE;
	m_bAlarmState	 = FALSE;
	m_bAlarmRelease	 = FALSE;
	m_bLoLimtSet	 = FALSE;
	m_bLoWarningSet  = FALSE;
	m_bUpWarningSet  = FALSE;
	m_sLimitAlarmState  = "NONE";
	m_bPermitAccess	 = FALSE;
	m_fLoLimitValue		= 0;
	m_fLoWarningValue	= 0;
	m_fUpLimitValue		= 0;
	m_fUpWarningValue	= 0;
	m_fSetPointInterlockValue = 0.0;

	m_bOnClickLock = FALSE;

	m_pDlg = new CDlgCalibration();
	m_iButton = 0;
}


/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlCtrl::~CAnalogCtrlCtrl - Destructor

CAnalogCtrlCtrl::~CAnalogCtrlCtrl()
{
	// TODO: Cleanup your control's instance data here.
	delete m_pDlg->m_pIniData;
	delete m_pIniData;

	delete m_pDlg;
}


/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlCtrl::OnDraw - Drawing function

void CAnalogCtrlCtrl::OnDraw( CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	DrawSlotList(pdc, rcBounds);
	m_rect = rcBounds;

}

/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlCtrl::DoPropExchange - Persistence support

void CAnalogCtrlCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);
	{
		PX_Short(pPX, _T("AnalogColor"), m_nType, 0);
		PX_Short(pPX, _T("AnalogRealId"), m_nAiRealID, 0);
		PX_Short(pPX, _T("ApdReportUnitNo"), m_nUnitNo, 0);
		PX_Short(pPX, _T("AnalogOcxCtlId"), m_nOcxCtrlID, 0);
		PX_Bool(pPX, _T("ApdReport"), m_bApdReport, FALSE);
		PX_Bool(pPX, _T("EdcReport"), m_bEdcReport, FALSE);
		PX_Bool(pPX, _T("Interlock"), m_bInterlockUsing, FALSE);
		PX_Bool(pPX, _T("Accumulate"), m_bAccumulate, FALSE);
		PX_Bool(pPX, _T("PrecentInterlock"), m_bPercentInterlock, FALSE);
		PX_String(pPX, _T("AnalogName"), m_sAiUnitName, FALSE);
	}
	GetAiProfileintData( m_nAiRealID );
}


/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlCtrl::OnResetState - Reset control to default state

void CAnalogCtrlCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlCtrl::AboutBox - Display an "About" box to the user

void CAnalogCtrlCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_ANALOGCTRL);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlCtrl message handlers

void CAnalogCtrlCtrl::DrawSlotList(CDC *pdc, const CRect &rcBounds)
{
	int nCellWidth = rcBounds.Width(); 
	int nCellHeight = rcBounds.Height();  // CST ̹Ƿ   ̸ ̰ Ѵ.
	
	int cx = rcBounds.left;
	int cy = rcBounds.top;

	//m_nFontSize = ( nCellWidth + nCellHeight )/5;
	
	//m_nFontSize = 
	COLORREF clrOldTextColor = pdc->SetTextColor ( RGB ( 0, 0, 0 ) );
	int nOldBkMod = pdc->SetBkMode( TRANSPARENT );
	
	CRect rect( 0, nCellHeight, nCellWidth , 0 );
	SetBackGround();
	CBrush brush ( m_emptyColor ) ;
	CBrush * pOldBrush = (CBrush * ) pdc->SelectObject(&brush);
	CFont Font;

	Font.CreateFont( m_nFontSize, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, 
		DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
		FIXED_PITCH|FF_MODERN|TMPF_TRUETYPE, "ARIAL" );
	pdc->SelectObject(&Font);

	pdc->Rectangle(rect);
	pdc->Draw3dRect ( rect, RGB ( 0, 0, 0 ), RGB ( 0, 0, 0 ) );
	rect.DeflateRect( nCellWidth, 2*nCellHeight);
	pdc->SetTextColor( RGB(0, 0, 0) );
	pdc->DrawText(m_sAiValue, rect, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
	pdc->SetBkMode ( nOldBkMod );
	pdc->SetTextColor ( clrOldTextColor );
}

void CAnalogCtrlCtrl::OnEmptyColorChanged() 
{
	// TODO: Add notification handler code
	SetModifiedFlag();
}

void CAnalogCtrlCtrl::SetColorCstSlot(OLE_COLOR ColorChange) 
{
	// TODO: Add your dispatch handler code here
	m_emptyColor = ColorChange;
	//InvalidateControl();
	SetModifiedFlag();
}

void CAnalogCtrlCtrl::SetBackGround()
{
	if( m_nOldType == m_nType ) return;
	if(m_nType == aiPS )      SetColorCstSlot( RGB(190, 255, 255) );
	else if(m_nType == aiFR ) SetColorCstSlot( RGB(255, 190, 190) ); //LIGHT_RED_COLOR;
	else if(m_nType == aiDM ) SetColorCstSlot( RGB(255, 255, 190) ); //LIGHT_YELLOW_COLOR;
	else if(m_nType == aiAM ) SetColorCstSlot( RGB(255, 220, 100) ); //WHITE_COLOR;
	else if(m_nType == aiWR ) SetColorCstSlot( RGB(255, 100, 100) ); 
	else if(m_nType == aiIC ) SetColorCstSlot( RGB(190, 190, 255) ); 
	else if(m_nType == aiTL ) SetColorCstSlot( RGB(255, 255, 255) ); 
	else if(m_nType == aiTM ) SetColorCstSlot( RGB(255, 220, 100) );
	else if(m_nType == aiIL ) SetColorCstSlot( RGB(255, 190, 255) ); // LIGHT_MAGENTA_COLOR;
	else if(m_nType == aiBAR ) SetColorCstSlot( RGB(100, 100, 255) );
	else if(m_nType == aiSLM ) SetColorCstSlot( RGB(255, 255, 100) ); 
	else if(m_nType == aiSCCM ) SetColorCstSlot( RGB(255, 255, 100) ); 
	else if(m_nType == aiALM ) SetColorCstSlot( RGB(255, 0, 0) ); // LIGHT_MAGENTA_COLOR;
	else if(m_nType == aiWORN ) SetColorCstSlot( RGB(100, 255, 255) ); // LIGHT_MAGENTA_COLOR;
	else if(m_nType == aiKGF )   SetColorCstSlot( RGB(190, 255, 255) );
	else if(m_nType == aiKV ) SetColorCstSlot( RGB(255, 220, 100) ); //WHITE_COLOR;
	else if(m_nType == aiMPA ) SetColorCstSlot( RGB(190, 255, 255) );
	else SetColorCstSlot( RGB(255, 255, 255) ); 
	m_nOldType = m_nType;
}

short CAnalogCtrlCtrl::GetGetAnalogColorSelect() 
{
	CString sGetID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );
	sGetID.Format("AI_TYPE%d",m_nAiRealID);
	m_nType = m_pIniData->GetIntValue("REAL_TYPE",sGetID,  0 );
	return m_nType;
}

void CAnalogCtrlCtrl::SetGetAnalogColorSelect(short nNewValue) 
{
	m_nType = nNewValue;
//	SetProfileini(m_nAiRealID);
	InvalidateControl();
	SetModifiedFlag();
}

BOOL CAnalogCtrlCtrl::GetApdReportSelect() 
{
	CString sGetID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );
	sGetID.Format("AI_USE_APD%d",m_nAiRealID);
	m_bApdReport = m_pIniData->GetIntValue("USE_APD",sGetID,  0 );
	return m_bApdReport;
}

void CAnalogCtrlCtrl::SetApdReportSelect(BOOL bNewValue) 
{
	// TODO: Add your property handler here
	m_bApdReport = bNewValue;
//	SetProfileini(m_nAiRealID);
	InvalidateControl();
	SetModifiedFlag();
}

BOOL CAnalogCtrlCtrl::GetEdcReportSelect() 
{
	// TODO: Add your property handler here
	CString sGetID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );
	sGetID.Format("AI_USE_EDC%d",m_nAiRealID);
	m_bEdcReport = m_pIniData->GetIntValue("USE_EDC",sGetID,  0 );
	return m_bEdcReport;
}

void CAnalogCtrlCtrl::SetEdcReportSelect(BOOL bNewValue) 
{
	m_bEdcReport = bNewValue;
//	SetProfileini(m_nAiRealID);
	InvalidateControl();
	SetModifiedFlag();
}

BOOL CAnalogCtrlCtrl::GetInterlockUsingSelect() 
{
	// TODO: Add your property handler here
	CString sGetID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );
	sGetID.Format("AI_USE_INT%d",m_nAiRealID);
	m_bInterlockUsing = m_pIniData->GetIntValue("USE_INT",sGetID,  0 );
	return m_bInterlockUsing;
}

void CAnalogCtrlCtrl::SetInterlockUsingSelect(BOOL bNewValue) 
{
	// TODO: Add your property handler here
	m_bInterlockUsing = bNewValue;
//	SetProfileini(m_nAiRealID);
	InvalidateControl();
	SetModifiedFlag();
}

short CAnalogCtrlCtrl::GetAiRealID() 
{
	// TODO: Add your property handler here
	CString sGetID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );
	sGetID.Format("AI_REAL_ADDRESS%d",m_nAiRealID);
	m_nAiRealID = m_pIniData->GetIntValue("REAL_ADDRESS",sGetID,  0 );
	return m_nAiRealID;
}

void CAnalogCtrlCtrl::SetAiRealID(short nNewValue) 
{
	// TODO: Add your property handler here
	m_nAiRealID = nNewValue;
//	SetProfileini(m_nAiRealID);
	InvalidateControl();
	SetModifiedFlag();
}

BSTR CAnalogCtrlCtrl::GetAnalogUnitName() 
{
	// TODO: Add your property handler here
	CString strResult;
	CString sGetID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );
	sGetID.Format("AI_ITEM_NAME%d",m_nAiRealID);
	m_sAiUnitName = m_pIniData->GetStringValue("ITEM_NAME",sGetID ,"0" );
	strResult = m_sAiUnitName;
	return strResult.AllocSysString();
}

void CAnalogCtrlCtrl::SetAnalogUnitName(LPCTSTR lpszNewValue) 
{
	// TODO: Add your property handler here
	m_sAiUnitName = lpszNewValue;
//	SetProfileini(m_nAiRealID);
	InvalidateControl();
	SetModifiedFlag();
}

void CAnalogCtrlCtrl::OnClick(USHORT iButton) 
{
	// TODO: Add your specialized code here and/or call the base class
	if( m_bOnClickLock ) return;
	m_bOnClickLock = TRUE;
	m_iButton = iButton;

	if( m_pDlg->m_hWnd == NULL )
	{
		m_pDlg->m_bPermitAccess  = m_bPermitAccess;
		m_pDlg->m_nID = m_nAiRealID;
		m_pDlg->m_sTilteName = GetAnalogUnitName();
		CRect r;
		m_pDlg->Create( "CDlgCalibration", "CALIBRATION", WS_VISIBLE, r, this, IDD_DLG_CALIBRATION, NULL );
	}
	m_pDlg->ShowWindow( SW_SHOW );

//	COleControl::OnClick(iButton);
}

void CAnalogCtrlCtrl::GetInitparameter()
{
	m_pDlg->GetCalInitPara( m_nAiRealID );
	SetLowLimitValue( m_pDlg->m_aiInfo.fLoLimit );
	SetSetLoWarningValue( m_pDlg->m_aiInfo.fLoWarning );
	SetUpLimitValue( m_pDlg->m_aiInfo.fUpLimit );
	SetUpWarningValue( m_pDlg->m_aiInfo.fUpWarning );
	m_bInitParameter = TRUE;
}

long CAnalogCtrlCtrl::GetAnalogcalculation() 
{
	// TODO: Add your property handler here
	return 0;
}

float CAnalogCtrlCtrl::GetCalculation() 
{
	// TODO: Add your dispatch handler code here
	return m_fCalcuAnalog;
}


void CAnalogCtrlCtrl::SetAlarmEnable() 
{
	// TODO: Add your dispatch handler code here
	m_nCurType = m_nType;
	SetTimer( 0, 500, NULL );
}

void CAnalogCtrlCtrl::SetAlarmState() 
{
	// TODO: Add your dispatch handler code here
	if( m_bAlarmState )
	{
		m_bAlarmState = FALSE;
		m_nType = aiALM;
		SetBackGround();
	}
	else
	{
		m_bAlarmState = TRUE;
		m_nType = m_nCurType;
		SetBackGround();
	}
	if( m_bLoLimtSet ) SetAlarmStateSetting( "L" );
	else if( m_bLoWarningSet ) SetAlarmStateSetting( "LW" );
	else if( m_bUpWarningSet ) SetAlarmStateSetting( "UW" );
	else if( m_bUpLimtSet ) SetAlarmStateSetting( "U" );

}

void CAnalogCtrlCtrl::SetAlarmRelease() 
{
	// TODO: Add your dispatch handler code here
	m_nType = m_nCurType;
	if( m_bLoLimtSet ) m_bLoLimtSet = FALSE;
	else if( m_bLoWarningSet ) m_bLoWarningSet = FALSE;
	else if( m_bUpWarningSet ) m_bUpWarningSet = FALSE;
	else if( m_bUpLimtSet ) m_bUpLimtSet = FALSE;
	m_bAlarmRelease = FALSE;
	m_sLimitAlarmState = "NONE";
	SetBackGround();
	KillTimer( 0 );
}

void CAnalogCtrlCtrl::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	float fCalcuValue = GetCalculation();

	if( m_bPercentInterlock )
	{
		if(  ( m_fSetPointInterlockValue - ( m_pDlg->m_aiInfo.fLoLimit/100. * m_fSetPointInterlockValue ) )  > fCalcuValue )
		{
			m_bAlarmRelease = FALSE;
			m_bLoLimtSet   = TRUE;
			SetAlarmState();
		}
		else if( ( m_fSetPointInterlockValue - ( m_pDlg->m_aiInfo.fLoWarning/100. * m_fSetPointInterlockValue ) ) > fCalcuValue )
		{
			m_bAlarmRelease = FALSE;
			m_bLoWarningSet   = TRUE;
			SetAlarmState();
		}
		else if( ( m_fSetPointInterlockValue - ( m_pDlg->m_aiInfo.fUpWarning/100. * m_fSetPointInterlockValue ) )  < fCalcuValue )
		{
			m_bAlarmRelease = FALSE;
			m_bUpWarningSet   = TRUE;
			SetAlarmState();
		}
		else if( ( m_fSetPointInterlockValue - ( m_pDlg->m_aiInfo.fUpLimit/100. * m_fSetPointInterlockValue ) ) < fCalcuValue  )
		{
			m_bAlarmRelease = FALSE;
			m_bUpLimtSet   = TRUE;
			SetAlarmState();
		}
		else
		{
			SetAlarmRelease();
		}
	}
	else
	{
		if( m_pDlg->m_aiInfo.fLoLimit > int( fCalcuValue ) )
		{
			m_bAlarmRelease = FALSE;
			m_bLoLimtSet   = TRUE;
			SetAlarmState();
		}
		else if( m_pDlg->m_aiInfo.fLoWarning > int( fCalcuValue ) )
		{
			m_bAlarmRelease = FALSE;
			m_bLoWarningSet   = TRUE;
			SetAlarmState();
		}
		else if ( m_pDlg->m_aiInfo.fUpLimit < int( fCalcuValue ) )
		{
			m_bAlarmRelease = FALSE;
			m_bUpLimtSet   = TRUE;
			SetAlarmState();
		}
		else if( m_pDlg->m_aiInfo.fUpWarning < int( fCalcuValue ) )
		{
			m_bAlarmRelease = FALSE;
			m_bUpWarningSet   = TRUE;
			SetAlarmState();
		}
		else
		{
			SetAlarmRelease();
		}
	}

	COleControl::OnTimer(nIDEvent);
}

short CAnalogCtrlCtrl::GetAnalogOcxCtlId() 
{
	// TODO: Add your property handler here
	CString sGetID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );
	sGetID.Format("AI_OCX_ID%d",m_nAiRealID);
	m_nOcxCtrlID = m_pIniData->GetIntValue("OCX_ID",sGetID,  0 );
	return m_nOcxCtrlID;
}

void CAnalogCtrlCtrl::SetAnalogOcxCtlId(short nNewValue) 
{
	// TODO: Add your property handler here
	m_nOcxCtrlID = nNewValue;
//	SetProfileini(m_nAiRealID);
	InvalidateControl();
	SetModifiedFlag();
}

BSTR CAnalogCtrlCtrl::GetAlarmStateSetting() 
{
	CString strResult;
	// TODO: Add your property handler here
	strResult = m_sLimitAlarmState;
	return strResult.AllocSysString();
}

void CAnalogCtrlCtrl::SetAlarmStateSetting(LPCTSTR lpszNewValue) 
{
	// TODO: Add your property handler here
	m_sLimitAlarmState = lpszNewValue;
	SetModifiedFlag();
}

float CAnalogCtrlCtrl::GetLowLimitValue() 
{
	// TODO: Add your property handler here

	return m_fLoLimitValue;
}

void CAnalogCtrlCtrl::SetLowLimitValue(float newValue) 
{
	// TODO: Add your property handler here
	m_fLoLimitValue = newValue;
	SetModifiedFlag();
}


float CAnalogCtrlCtrl::GetSetLoWarningValue() 
{
	// TODO: Add your property handler here

	return m_fLoWarningValue;
}

void CAnalogCtrlCtrl::SetSetLoWarningValue(float newValue) 
{
	// TODO: Add your property handler here
	m_fLoWarningValue = newValue;
	SetModifiedFlag();
}

float CAnalogCtrlCtrl::GetUpLimitValue() 
{
	// TODO: Add your property handler here

	return m_fUpLimitValue;
}

void CAnalogCtrlCtrl::SetUpLimitValue(float newValue) 
{
	// TODO: Add your property handler here
	m_fUpLimitValue = newValue;
	SetModifiedFlag();
}

float CAnalogCtrlCtrl::GetUpWarningValue() 
{
	// TODO: Add your property handler here

	return m_fUpWarningValue;
}

void CAnalogCtrlCtrl::SetUpWarningValue(float newValue) 
{
	// TODO: Add your property handler here
	m_fUpWarningValue = newValue;
	SetModifiedFlag();
}

void CAnalogCtrlCtrl::SetKindOfUnit(LPCTSTR lpszNewValue) 
{
	// TODO: Add your property handler here

	SetModifiedFlag();
}


short CAnalogCtrlCtrl::GetAdcMinVal() 
{
	// TODO: Add your property handler here

	return m_pDlg->m_aiInfo.nAdcMin;
}

void CAnalogCtrlCtrl::SetAdcMinVal(short nNewValue) 
{
	// TODO: Add your property handler here
	SetModifiedFlag();
}

short CAnalogCtrlCtrl::GetAdcMaxVal() 
{
	// TODO: Add your property handler here

	return m_pDlg->m_aiInfo.nAdcMax;
}

void CAnalogCtrlCtrl::SetAdcMaxVal(short nNewValue) 
{
	// TODO: Add your property handler here

	SetModifiedFlag();
}

float CAnalogCtrlCtrl::GetRealMinVal() 
{
	// TODO: Add your property handler here
	return m_pDlg->m_aiInfo.fRealMin;
}

void CAnalogCtrlCtrl::SetRealMinVal(float newValue) 
{
	// TODO: Add your property handler here
	SetModifiedFlag();
}

float CAnalogCtrlCtrl::GetRealMaxVal() 
{
	// TODO: Add your property handler here
	return m_pDlg->m_aiInfo.fRealMax;
}

void CAnalogCtrlCtrl::SetRealMaxVal(float newValue) 
{
	// TODO: Add your property handler here

	SetModifiedFlag();
}

float CAnalogCtrlCtrl::GetAnalogCalDisplay() 
{
	// TODO: Add your property handler here

	return 0.0f;
}

void CAnalogCtrlCtrl::SetAnalogCalDisplay(float newValue) 
{
	// TODO: Add your property handler here
	m_fCalcuAnalog = newValue;
 	m_pDlg->m_aiInfo.fCurReal = newValue;
	if( m_nType == aiPS ) m_sAiValue.Format( "%3.2f kPa", m_fCalcuAnalog );
	else if( m_nType == aiFR ) m_sAiValue.Format( "%3.2f lpm", m_fCalcuAnalog );
	else if( m_nType == aiDM ) m_sAiValue.Format( "%3.2f Pa", m_fCalcuAnalog );
	else if( m_nType == aiAM ) m_sAiValue.Format( "%3.2f mm/s", m_fCalcuAnalog );
	else if( m_nType == aiWR ) m_sAiValue.Format( "%3.3f Mohm", m_fCalcuAnalog );
	else if( m_nType == aiIC ) m_sAiValue.Format( "%3.2f V", m_fCalcuAnalog );
	else if( m_nType == aiTL ) m_sAiValue.Format( "%3.2f L", m_fCalcuAnalog );
	else if( m_nType == aiTM ) m_sAiValue.Format( "%3.2f deg", m_fCalcuAnalog );
	else if( m_nType == aiBAR ) m_sAiValue.Format( "%3.2f bar", m_fCalcuAnalog );
	else if( m_nType == aiSLM ) m_sAiValue.Format( "%3.2f slm", m_fCalcuAnalog );
	else if( m_nType == aiSCCM ) m_sAiValue.Format( "%3.2f sccm", m_fCalcuAnalog );
	else if( m_nType == aiKGF ) m_sAiValue.Format( "%3.2f kg/cm^2", m_fCalcuAnalog );
	else if( m_nType == aiKV ) m_sAiValue.Format( "%3.2f kV", m_fCalcuAnalog );
 	else if( m_nType == aiMPA ) m_sAiValue.Format( "%3.2f MPa", m_fCalcuAnalog );
	Refresh();
}

BOOL CAnalogCtrlCtrl::GetPermitAccess() 
{
	// TODO: Add your property handler here
	return TRUE;
}

void CAnalogCtrlCtrl::SetPermitAccess(BOOL bNewValue) 
{
	// TODO: Add your property handler here
	m_bPermitAccess = bNewValue;
	SetModifiedFlag();
}

long CAnalogCtrlCtrl::GetCurAdcVal() 
{
	// TODO: Add your property handler here

	return 0;
}

void CAnalogCtrlCtrl::SetCurAdcVal(long nNewValue) 
{
	// TODO: Add your property handler here
	m_pDlg->m_aiInfo.nCurAdc = nNewValue;
	SetModifiedFlag();
}

short CAnalogCtrlCtrl::GetCalScale() 
{
	// TODO: Add your property handler here
	return m_pDlg->m_aiInfo.nScale;
}

void CAnalogCtrlCtrl::SetCalScale(short nNewValue) 
{
	// TODO: Add your property handler here

	SetModifiedFlag();
}

short CAnalogCtrlCtrl::GetInitParameter() 
{
	// TODO: Add your property handler here
	return 0;
}

void CAnalogCtrlCtrl::SetInitParameter(short nNewValue) 
{
	// TODO: Add your property handler here
	m_pDlg->GetCalInitPara( nNewValue );
	SetModifiedFlag();
}

short CAnalogCtrlCtrl::GetApdReportUnitNo() 
{
	// TODO: Add your property handler here
	CString sGetID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );
	sGetID.Format("AI_UNIT_NO%d",m_nAiRealID);
	m_nUnitNo = m_pIniData->GetIntValue("UNIT_NO",sGetID,  0 );
	return m_nUnitNo;
}

void CAnalogCtrlCtrl::SetApdReportUnitNo(short nNewValue ) 
{
	// TODO: Add your property handler here
	m_nUnitNo = nNewValue;
//	SetProfileini(m_nAiRealID);
	SetModifiedFlag();
}

short CAnalogCtrlCtrl::GetProfileini() 
{
	// TODO: Add your property handler here

	return 0;
}

void CAnalogCtrlCtrl::SetProfileini(short nNewValue ) 
{
	// TODO: Add your property handler here
	CString sGetID;
	int nID;
	nID = nNewValue;
	m_pIniData->Open("AiOcxPraSet","AiControl" );

	sGetID.Format("AI_OCX_ID%d",nID);
	m_pIniData->SetIntValue( "OCX_ID", sGetID ,m_nOcxCtrlID, TRUE );

	sGetID.Format("AI_REAL_ADDRESS%d",nID);
	m_pIniData->SetIntValue( "REAL_ADDRESS",sGetID ,m_nAiRealID, TRUE ); //  ּ 
	
	sGetID.Format("AI_UNIT_NO%d",nID);
	m_pIniData->SetIntValue( "UNIT_NO",sGetID ,m_nUnitNo, TRUE ); 
	
	sGetID.Format("AI_ITEM_NAME%d",nID);
	m_pIniData->SetStringValue("ITEM_NAME",sGetID ,m_sAiUnitName, TRUE );
	
	sGetID.Format("AI_USE_INT%d",nID);
	m_pIniData->SetIntValue( "USE_INT",sGetID ,m_bInterlockUsing, TRUE ); 
	
	sGetID.Format("AI_USE_APD%d",nID);
	m_pIniData->SetIntValue( "USE_APD",sGetID ,m_bApdReport, TRUE ); 
	
	sGetID.Format("AI_USE_EDC%d",nID);
	m_pIniData->SetIntValue( "USE_EDC",sGetID ,m_bEdcReport, TRUE ); 

	sGetID.Format("AI_USE_ACUM%d",nID);
	m_pIniData->SetIntValue( "USE_ACUM",sGetID ,m_bAccumulate, TRUE ); 

	sGetID.Format("AI_USE_PERCENT%d",nID);
	m_pIniData->SetIntValue( "USE_PERCENT",sGetID ,m_bPercentInterlock, TRUE );
	
	sGetID.Format("AI_TYPE%d",nID);
	m_pIniData->SetIntValue( "REAL_TYPE",sGetID ,m_nType, TRUE ); 

	SetModifiedFlag();
}

void CAnalogCtrlCtrl::GetAiProfileintData(int nCtrlId )
{
	CString sGetID;
	int nID = nCtrlId;
	m_pIniData->Open("AiOcxPraSet","AiControl" );

	sGetID.Format("AI_OCX_ID%d",nID);
	m_nOcxCtrlID = m_pIniData->GetIntValue( "OCX_ID", sGetID , 0 );

	sGetID.Format("AI_REAL_ADDRESS%d",nID);
	m_nAiRealID = m_pIniData->GetIntValue("REAL_ADDRESS",sGetID,  0 );

	sGetID.Format("AI_UNIT_NO%d",nID);
	m_nUnitNo = m_pIniData->GetIntValue("UNIT_NO",sGetID,  0 );

	sGetID.Format("AI_ITEM_NAME%d",nID);
	m_sAiUnitName = m_pIniData->GetStringValue("ITEM_NAME",sGetID ,"0" );
	
	sGetID.Format("AI_USE_INT%d",nID);
	m_bInterlockUsing = m_pIniData->GetIntValue("USE_INT",sGetID,  0 );

	sGetID.Format("AI_USE_APD%d",nID);
	m_bApdReport = m_pIniData->GetIntValue("USE_APD",sGetID,  0 );

	sGetID.Format("AI_USE_EDC%d",nID);
	m_bEdcReport = m_pIniData->GetIntValue("USE_EDC",sGetID,  0 );

	sGetID.Format("AI_USE_ACUM%d",nID);
	m_bAccumulate = m_pIniData->GetIntValue("USE_ACUM",sGetID,  0 );

	sGetID.Format("AI_USE_PERCENT%d",nID);
	m_bPercentInterlock = m_pIniData->GetIntValue("USE_PERCENT",sGetID,  0 );

	sGetID.Format("AI_TYPE%d",nID);
	m_nType = m_pIniData->GetIntValue("REAL_TYPE",sGetID,  0 );
}

short CAnalogCtrlCtrl::GetApdReportID() 
{
	// TODO: Add your dispatch handler code here
	if( m_bApdReport ) return m_nOcxCtrlID;
	else return -1;
}

short CAnalogCtrlCtrl::GetInitParameterSet() 
{
	// TODO: Add your property handler here

	return 0;
}

void CAnalogCtrlCtrl::SetInitParameterSet(short nNewValue) 
{
	// TODO: Add your property handler here
	m_pDlg->GetCalInitPara( nNewValue );
	SetModifiedFlag();
}

BOOL CAnalogCtrlCtrl::GetAccumulate() 
{
	// TODO: Add your property handler here
	CString sGetID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );
	sGetID.Format("AI_USE_ACUM%d",m_nAiRealID);
	m_bAccumulate = m_pIniData->GetIntValue("USE_ACUM",sGetID,  0 );
	return m_bAccumulate;
}

void CAnalogCtrlCtrl::SetAccumulate(BOOL bNewValue) 
{
	// TODO: Add your property handler here
	m_bAccumulate = bNewValue;
//	SetProfileini( m_nAiRealID );
	InvalidateControl();
	SetModifiedFlag();
}

BOOL CAnalogCtrlCtrl::GetPercentInterlock() 
{
	// TODO: Add your property handler here

	CString sGetID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );
	sGetID.Format("AI_USE_PERCENT%d",m_nAiRealID);
	m_bPercentInterlock = m_pIniData->GetIntValue("USE_PERCENT",sGetID,  0 );
	return m_bPercentInterlock;
}

void CAnalogCtrlCtrl::SetPercentInterlock(BOOL bNewValue) 
{
	// TODO: Add your property handler here
	m_bPercentInterlock = bNewValue;
//	SetProfileini(m_nAiRealID);
	InvalidateControl();
	SetModifiedFlag();
}

float CAnalogCtrlCtrl::GetSetPointInterlockValue() 
{
	// TODO: Add your property handler here

	return m_fSetPointInterlockValue;
}

void CAnalogCtrlCtrl::SetSetPointInterlockValue(float newValue) 
{
	// TODO: Add your property handler here
	m_fSetPointInterlockValue = newValue;
	SetModifiedFlag();
}

BSTR CAnalogCtrlCtrl::GetKindOfUnit() 
{
	CString strResult;
	CString sGetID;	
	m_pIniData->Open("AiOcxPraSet","AiControl" );
	sGetID.Format("AI_TYPE%d",m_nAiRealID);
	m_nType = m_pIniData->GetIntValue("REAL_TYPE",sGetID,  0 );

	if( m_nType == aiPS ) strResult = "kPa";
	else if( m_nType == aiFR ) strResult = "lpm";
	else if( m_nType == aiDM ) strResult = "Pa"; 
	else if( m_nType == aiAM ) strResult = "mm/s";  
	else if( m_nType == aiWR ) strResult = "Mohm"; 
	else if( m_nType == aiIC ) strResult = "V";
	else if( m_nType == aiTL ) strResult = "L";
	else if( m_nType == aiTM ) strResult = "deg";
	else if( m_nType == aiBAR ) strResult = "bar";
	else if( m_nType == aiSCCM ) strResult = "sccm";
	else if( m_nType == aiSLM ) strResult = "slm";
	else if( m_nType == aiKGF ) strResult = "kg/cm^2";
	else if( m_nType == aiKV ) strResult = "kV";
	else if( m_nType == aiMPA ) strResult = "MPa";
	else if( m_nType == aiAM )  strResult = "";
	
	return strResult.AllocSysString();
}

float CAnalogCtrlCtrl::GetPointInterlockValue() 
{
	// TODO: Add your property handler here

	return m_fSetPointInterlockValue;
}

void CAnalogCtrlCtrl::SetPointInterlockValue(float newValue) 
{
	// TODO: Add your property handler here
	m_fSetPointInterlockValue = newValue;
	SetModifiedFlag();
}

float CAnalogCtrlCtrl::GetFilterGain() 
{
	// TODO: Add your property handler here

	return m_pDlg->m_aiInfo.m_fFilterGain;
}

void CAnalogCtrlCtrl::SetFilterGain(float newValue) 
{
	// TODO: Add your property handler here
//	m_pDlg->m_aiInfo.m_fFilterGain = newValue;
	SetModifiedFlag();
}

void CAnalogCtrlCtrl::OnCalibrationEnd( WPARAM wParam, LPARAM lParam )
{
	if( m_pDlg->IsWindowEnabled() )
	{
		m_pDlg->DestroyWindow();
	}
	
	SetLowLimitValue( m_pDlg->m_aiInfo.fLoLimit );
	SetSetLoWarningValue( m_pDlg->m_aiInfo.fLoWarning );
	SetUpLimitValue( m_pDlg->m_aiInfo.fUpLimit );
	SetUpWarningValue( m_pDlg->m_aiInfo.fUpWarning );

	m_bOnClickLock = FALSE;
	COleControl::OnClick(m_iButton);
}
