#if !defined(AFX_ANALOGCTRLCTL_H__3ADF7885_1951_46AB_BE10_1E0A93BD9D2F__INCLUDED_)
#define AFX_ANALOGCTRLCTL_H__3ADF7885_1951_46AB_BE10_1E0A93BD9D2F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// AnalogCtrlCtl.h : Declaration of the CAnalogCtrlCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlCtrl : See AnalogCtrlCtl.cpp for implementation.
#include "DlgCalibration.h"
#include "IniData.h"	// Added by ClassView

class CAnalogCtrlCtrl : public COleControl
{
	DECLARE_DYNCREATE(CAnalogCtrlCtrl)

// Constructor
public:
	CAnalogCtrlCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAnalogCtrlCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual void OnClick(USHORT iButton);
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CAnalogCtrlCtrl();

	DECLARE_OLECREATE_EX(CAnalogCtrlCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CAnalogCtrlCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CAnalogCtrlCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CAnalogCtrlCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CAnalogCtrlCtrl)
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	afx_msg void OnCalibrationEnd( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CAnalogCtrlCtrl)
	OLE_COLOR m_emptyColor;
	afx_msg void OnEmptyColorChanged();
	afx_msg short GetGetAnalogColorSelect();
	afx_msg void SetGetAnalogColorSelect(short nNewValue);
	afx_msg BOOL GetApdReportSelect();
	afx_msg void SetApdReportSelect(BOOL bNewValue);
	afx_msg short GetAiRealID();
	afx_msg void SetAiRealID(short nNewValue);
	afx_msg BOOL GetInterlockUsingSelect();
	afx_msg void SetInterlockUsingSelect(BOOL bNewValue);
	afx_msg BOOL GetEdcReportSelect();
	afx_msg void SetEdcReportSelect(BOOL bNewValue);
	afx_msg BSTR GetAnalogUnitName();
	afx_msg void SetAnalogUnitName(LPCTSTR lpszNewValue);
	afx_msg long GetAnalogcalculation();
	afx_msg BSTR GetAlarmStateSetting();
	afx_msg void SetAlarmStateSetting(LPCTSTR lpszNewValue);
	afx_msg short GetLowLimitValue();
	afx_msg void SetLowLimitValue(short nNewValue);
	afx_msg short GetLoWaringValue();
	afx_msg void SetLoWaringValue(short nNewValue);
	afx_msg short GetUpLimitValue();
	afx_msg void SetUpLimitValue(short nNewValue);
	afx_msg short GetUpWarningValue();
	afx_msg void SetUpWarningValue(short nNewValue);
	afx_msg short GetAdcMinVal();
	afx_msg void SetAdcMinVal(short nNewValue);
	afx_msg short GetAdcMaxVal();
	afx_msg void SetAdcMaxVal(short nNewValue);
	afx_msg float GetRealMinVal();
	afx_msg void SetRealMinVal(float newValue);
	afx_msg float GetRealMaxVal();
	afx_msg void SetRealMaxVal(float newValue);
	afx_msg float GetAnalogCalDisplay();
	afx_msg void SetAnalogCalDisplay(float newValue);
	afx_msg BOOL GetPermitAccess();
	afx_msg void SetPermitAccess(BOOL bNewValue);
	afx_msg long GetCurAdcVal();
	afx_msg void SetCurAdcVal(long nNewValue);
	afx_msg short GetCalScale();
	afx_msg void SetCalScale(short nNewValue);
	afx_msg short GetInitParameter();
	afx_msg void SetInitParameter(short nNewValue);
	afx_msg short GetApdReportUnitNo();
	afx_msg void SetApdReportUnitNo(short nNewValue);
	afx_msg short GetProfileini();
	afx_msg void SetProfileini(short nNewValue);
	afx_msg short GetAnalogOcxCtlId();
	afx_msg void SetAnalogOcxCtlId(short nNewValue);
	afx_msg short GetInitParameterSet();
	afx_msg void SetInitParameterSet(short nNewValue);
	afx_msg BOOL GetAccumulate();
	afx_msg void SetAccumulate(BOOL bNewValue);
	afx_msg BOOL GetPercentInterlock();
	afx_msg void SetPercentInterlock(BOOL bNewValue);
	afx_msg float GetSetPointInterlockValue();
	afx_msg void SetSetPointInterlockValue(float newValue);
	afx_msg float GetPointInterlockValue();
	afx_msg void SetPointInterlockValue(float newValue);
	afx_msg float GetFilterGain();
	afx_msg void SetFilterGain(float newValue);
	afx_msg void SetColorCstSlot(OLE_COLOR ColorChange);
	afx_msg float GetCalculation();
	afx_msg void SetAlarmEnable();
	afx_msg void SetAlarmState();
	afx_msg void SetAlarmRelease();
	afx_msg short GetApdReportID();
	afx_msg BSTR GetUnitOfKind(short CtrlId);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CAnalogCtrlCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	BOOL m_bOnClickLock;
	USHORT m_iButton;

	float m_fSetPointInterlockValue;
	void GetAiProfileintData( int nCtrlId);

	CIniData * m_pIniData;

	BOOL m_bPermitAccess;
	int m_nUpWarnigValue;
	int m_nUpLimitValue;
	int m_nLoWarnigValue;
	int m_nLoLimitValue;
	int m_nCurAdc;
	BOOL m_bLoWarningSet;
	BOOL m_bLoLimtSet;
	BOOL m_bUpWarningSet;
	BOOL m_bUpLimtSet;

	CString m_sLimitAlarmState;
	BOOL m_bAlarmRelease;
	BOOL m_bAlarmState;
	int m_nCurType;
	BOOL m_bRun;
	float m_fCalcuAnalog;
	int m_nOldAdc;
	BOOL m_bFirstVal;
	int m_nAnalogInput;
	CDlgCalibration*  m_pDlg;
	BOOL m_bInitParameter;
	void GetInitparameter();
	BOOL m_bApdReport;
	BOOL m_bEdcReport;
	BOOL m_bInterlockUsing;
	BOOL m_bAccumulate;
	BOOL m_bPercentInterlock;
	short m_nAiRealID;
	short m_nUnitNo;
	short m_nOcxCtrlID;
	int m_nOldType;
	CRect m_rect;
	int m_nFontSize;
	CString m_sAiValue;
	CString m_sAiUnitName;
	void SetBackGround();
	enum aiKIND { aiPS, aiFR, aiDM, aiAM, aiWR, aiIC, aiTL, aiTM, aiIL,aiBAR,aiSCCM, aiALM, aiWORN,   };
	short	m_nType;
	void DrawSlotList(CDC *pdc, const CRect &rcBounds);
	enum {
	//{{AFX_DISP_ID(CAnalogCtrlCtrl)
	dispidEmptyColor = 1L,
	dispidGetAnalogColorSelect = 2L,
	dispidApdReportSelect = 3L,
	dispidAiRealID = 4L,
	dispidInterlockUsingSelect = 5L,
	dispidEdcReportSelect = 6L,
	dispidAnalogUnitName = 7L,
	dispidAnalogcalculation = 8L,
	dispidAlarmStateSetting = 9L,
	dispidLowLimitValue = 10L,
	dispidLoWaringValue = 11L,
	dispidUpLimitValue = 12L,
	dispidUpWarningValue = 13L,
	dispidAdcMinVal = 14L,
	dispidAdcMaxVal = 15L,
	dispidRealMinVal = 16L,
	dispidRealMaxVal = 17L,
	dispidAnalogCalDisplay = 18L,
	dispidPermitAccess = 19L,
	dispidCurAdcVal = 20L,
	dispidCalScale = 21L,
	dispidInitParameter = 22L,
	dispidApdReportUnitNo = 23L,
	dispidProfileini = 24L,
	dispidAnalogOcxCtlId = 25L,
	dispidInitParameterSet = 26L,
	dispidAccumulate = 27L,
	dispidPercentInterlock = 29L,
	dispidPointInterlockValue = 30L,
	dispidFilterGain = 31L,
	dispidSetColorCstSlot = 32L,
	dispidGetCalculation = 33L,
	dispidSetAlarmEnable = 34L,
	dispidSetAlarmState = 35L,
	dispidSetAlarmRelease = 36L,
	dispidGetApdReportID = 37L,
	dispidGetUnitOfKind = 38L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ANALOGCTRLCTL_H__3ADF7885_1951_46AB_BE10_1E0A93BD9D2F__INCLUDED)
