// AnalogCtrlPpg.cpp : Implementation of the CAnalogCtrlPropPage property page class.

#include "stdafx.h"
#include "AnalogCtrl.h"
#include "AnalogCtrlPpg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CAnalogCtrlPropPage, COlePropertyPage)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CAnalogCtrlPropPage, COlePropertyPage)
	//{{AFX_MSG_MAP(CAnalogCtrlPropPage)
	ON_BN_CLICKED(IDC_READ_INFO_BUTTON, OnReadInfoButton)
	ON_BN_CLICKED(IDC_SAVE_INFO_BUTTON, OnSaveInfoButton)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CAnalogCtrlPropPage, "ANALOGCTRL.AnalogCtrlPropPage.1",
	0x13558575, 0xef68, 0x4799, 0xb5, 0x38, 0x57, 0x94, 0x92, 0x26, 0xbc, 0x56)


/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlPropPage::CAnalogCtrlPropPageFactory::UpdateRegistry -
// Adds or removes system registry entries for CAnalogCtrlPropPage

BOOL CAnalogCtrlPropPage::CAnalogCtrlPropPageFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterPropertyPageClass(AfxGetInstanceHandle(),
			m_clsid, IDS_ANALOGCTRL_PPG);
	else
		return AfxOleUnregisterClass(m_clsid, NULL);
}


/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlPropPage::CAnalogCtrlPropPage - Constructor

CAnalogCtrlPropPage::CAnalogCtrlPropPage() :
	COlePropertyPage(IDD, IDS_ANALOGCTRL_PPG_CAPTION)
{
	//{{AFX_DATA_INIT(CAnalogCtrlPropPage)
//	m_nType = -1;
//	m_bApdReport = FALSE;
//	m_bEdcReport = FALSE;
//	m_bInterlockUsing = FALSE;
//	m_bAccumulate	= FALSE;
//	m_bPercentInterlock = FALSE;

//	m_nAiRealID = 0;
//	m_sAiUnitName = _T("");
	//}}AFX_DATA_INIT
	m_pIniData = new CIniData;
}


/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlPropPage::DoDataExchange - Moves data between page and properties

void CAnalogCtrlPropPage::DoDataExchange(CDataExchange* pDX)
{
	//{{AFX_DATA_MAP(CAnalogCtrlPropPage)
	DDP_Radio(pDX, IDC_RADIO1, m_nType, _T("AnalogColor") );
	DDX_Radio(pDX, IDC_RADIO1, m_nType);
	DDP_Check(pDX, IDC_CHECK1, m_bApdReport, _T("ApdReport") );
	DDX_Check(pDX, IDC_CHECK1, m_bApdReport);
	DDP_Check(pDX, IDC_CHECK2, m_bEdcReport, _T("EdcReport") );
	DDX_Check(pDX, IDC_CHECK2, m_bEdcReport);
	DDP_Check(pDX, IDC_CHECK3, m_bInterlockUsing, _T("Interlock") );
	DDX_Check(pDX, IDC_CHECK3, m_bInterlockUsing);
	DDP_Check(pDX, IDC_CHECK4, m_bAccumulate, _T("Accumulate") );
	DDX_Check(pDX, IDC_CHECK4, m_bAccumulate);
	DDP_Check(pDX, IDC_CHECK5, m_bPercentInterlock, _T("PrecentInterlock") );
	DDX_Check(pDX, IDC_CHECK5, m_bPercentInterlock);
	DDP_Text(pDX, IDC_EDIT1, m_nAiRealID, _T("AnalogRealId") );
	DDX_Text(pDX, IDC_EDIT1, m_nAiRealID);
	DDP_Text(pDX, IDC_EDIT2, m_sAiUnitName, _T("AnalogName") );
	DDX_Text(pDX, IDC_EDIT2, m_sAiUnitName);
	DDP_Text(pDX, IDC_EDIT3, m_nUnitNo, _T("ApdReportUnitNo") );
	DDX_Text(pDX, IDC_EDIT3, m_nUnitNo);
	DDP_Text(pDX, IDC_EDIT4, m_nOcxCtrlID, _T("AnalogOcxCtlId") );
	DDX_Text(pDX, IDC_EDIT4, m_nOcxCtrlID);
	//}}AFX_DATA_MAP
	DDP_PostProcessing(pDX);
}

/////////////////////////////////////////////////////////////////////////////
// CAnalogCtrlPropPage message handlers

BOOL CAnalogCtrlPropPage::OnInitDialog() 
{
	COlePropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAnalogCtrlPropPage::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	delete m_pIniData;

	COlePropertyPage::OnClose();
}

void CAnalogCtrlPropPage::OnReadInfoButton() 
{
	// TODO: Add your control notification handler code here
	CString sGetID;
	int nID = m_nAiRealID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );

	sGetID.Format("AI_OCX_ID%d",nID);
	m_nOcxCtrlID = m_pIniData->GetIntValue( "OCX_ID", sGetID , 0 );

	sGetID.Format("AI_UNIT_NO%d",nID);
	m_nUnitNo = m_pIniData->GetIntValue("UNIT_NO",sGetID,  0 );

	sGetID.Format("AI_ITEM_NAME%d",nID);
	m_sAiUnitName = m_pIniData->GetStringValue("ITEM_NAME",sGetID ,"0" );
	
	sGetID.Format("AI_USE_INT%d",nID);
	m_bInterlockUsing = m_pIniData->GetIntValue("USE_INT",sGetID,  0 );

	sGetID.Format("AI_USE_APD%d",nID);
	m_bApdReport = m_pIniData->GetIntValue("USE_APD",sGetID,  0 );

	sGetID.Format("AI_USE_EDC%d",nID);
	m_bEdcReport = m_pIniData->GetIntValue("USE_EDC",sGetID,  0 );

	sGetID.Format("AI_USE_ACUM%d",nID);
	m_bAccumulate = m_pIniData->GetIntValue("USE_ACUM",sGetID,  0 );

	sGetID.Format("AI_USE_PERCENT%d",nID);
	m_bPercentInterlock = m_pIniData->GetIntValue("USE_PERCENT",sGetID,  0 );

	sGetID.Format("AI_TYPE%d",nID);
	m_nType = m_pIniData->GetIntValue("REAL_TYPE",sGetID,  0 );	

	UpdateData( FALSE );
}

void CAnalogCtrlPropPage::OnSaveInfoButton() 
{
	// TODO: Add your control notification handler code here
	CString sGetID;
	int nID = m_nAiRealID;
	m_pIniData->Open("AiOcxPraSet","AiControl" );

	sGetID.Format("AI_OCX_ID%d",nID);
	m_pIniData->SetIntValue( "OCX_ID", sGetID ,m_nOcxCtrlID, TRUE );

	sGetID.Format("AI_REAL_ADDRESS%d",nID);
	m_pIniData->SetIntValue( "REAL_ADDRESS",sGetID ,m_nAiRealID, TRUE ); //  ּ 
	
	sGetID.Format("AI_UNIT_NO%d",nID);
	m_pIniData->SetIntValue( "UNIT_NO",sGetID ,m_nUnitNo, TRUE ); 
	
	sGetID.Format("AI_ITEM_NAME%d",nID);
	m_pIniData->SetStringValue("ITEM_NAME",sGetID ,m_sAiUnitName, TRUE );
	
	sGetID.Format("AI_USE_INT%d",nID);
	m_pIniData->SetIntValue( "USE_INT",sGetID ,m_bInterlockUsing, TRUE ); 
	
	sGetID.Format("AI_USE_APD%d",nID);
	m_pIniData->SetIntValue( "USE_APD",sGetID ,m_bApdReport, TRUE ); 
	
	sGetID.Format("AI_USE_EDC%d",nID);
	m_pIniData->SetIntValue( "USE_EDC",sGetID ,m_bEdcReport, TRUE ); 

	sGetID.Format("AI_USE_ACUM%d",nID);
	m_pIniData->SetIntValue( "USE_ACUM",sGetID ,m_bAccumulate, TRUE ); 

	sGetID.Format("AI_USE_PERCENT%d",nID);
	m_pIniData->SetIntValue( "USE_PERCENT",sGetID ,m_bPercentInterlock, TRUE );
	
	sGetID.Format("AI_TYPE%d",nID);
	m_pIniData->SetIntValue( "REAL_TYPE",sGetID ,m_nType, TRUE ); 

	SetModifiedFlag();	
}
