#if !defined(AFX_DLGCALIBRATION_H__6B32213A_BFB2_489C_BFFE_7394026DCB42__INCLUDED_)
#define AFX_DLGCALIBRATION_H__6B32213A_BFB2_489C_BFFE_7394026DCB42__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgCalibration.h : header file
//
#include "MacButtons.h"
#include "DlgSelSensor.h"
#include "IniData.h"	// Added by ClassView

/////////////////////////////////////////////////////////////////////////////
// CDlgCalibration dialog
#define WM_CALIBRATION_END		WM_USER + 101

class CDlgCalibration : public CDialog
{
// Construction
public:
	CString m_sTilteName;
	void SetLimitAlarmSet(int nID, float nLoLimt, float nLoWarning, float nUpWarning, float nUpLimt );
	void GetLimitAlarmSet( int nID );
	void SetAiCalScale(int nID, int nScale);
	void GetAiCalScale(int nID, int &nScale);
	void DefaultSetting( int nSensorType );
	void GetCalInitPara( int nID );
	
	void SetFilterGain(int nID, float f);
	void GetCalPara(int nID);
	CString m_sEntry;
	int m_nID;
	void SetCalPara(int nID,float fRealMax, float fRealMin, int nAdcMax, int nAdcMin);
	CDlgCalibration(CWnd* pParent = NULL);   // standard constructor

	CDlgSelSensor* m_pDlg;
	CIniData * m_pIniData;
	
	CWnd*	m_pParentWnd;
	BOOL	m_bPermitAccess;

// Dialog Data
	//{{AFX_DATA(CDlgCalibration)
	enum { IDD = IDD_DLG_CALIBRATION };
	int		m_nAdcMax;
	int		m_nAdcMin;
	int		m_nCurAdc;
	float	m_fCurReal;
	float	m_fRealMax;
	float	m_fRealMin;
	float	m_fFilterGain;
	CMacRadioButton	m_macLimitSet;
	CMacRadioButton	m_macCalibration;
	CMacRadioButton	m_macDefault;
	CMacRadioButton m_macCommon;
	CMacRadioButton m_macLog;
	CMacRadioButton m_macLog10;
	float	m_fLowWarning;
	float	m_fLowLimit;
	float	m_fUpLimit;
	float	m_fUpWarning;
	//}}AFX_DATA

	struct aiInfo
	{
		int nAdcMax;
		int nAdcMin;
		float fRealMax;
		float fRealMin;
		float m_fFilterGain;
		int nCurAdc;
		float fCurReal;
		float fLoLimit;
		float fUpLimit;
		float fLoWarning;
		float fUpWarning;
		BOOL bUseInterlock;
		BOOL bUseWarning;
		int nScale;
	} m_aiInfo;

	enum _aiScale{
		scaleCOMMON,
		scaleLOG10,
		scaleLOG,
	};

	int		m_nAdcMaxinit;
	int		m_nScale;

	CBitmapButton		m_Ok;
	CBitmapButton		m_Cancel;

	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgCalibration)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgCalibration)
	afx_msg void OnCalibration();
	virtual BOOL OnInitDialog();
	afx_msg void OnDefault();
	afx_msg void OnLimitSet();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	virtual void OnOK();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGCALIBRATION_H__6B32213A_BFB2_489C_BFFE_7394026DCB42__INCLUDED_)
