// DlgSelSensor.cpp : implementation file
//

#include "stdafx.h"
#include "AnalogCtrl.h"
#include "DlgSelSensor.h"
#include "DlgCalibration.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgSelSensor dialog

AI_PRESET CDlgSelSensor::m_aiPreSet[enMAX_SENSOR_TYPE] =
{
	{ enPG35		, "PG35",						0.,		1000.,	0xCCC,	0x3000 },
	{ enDW_605		, "Dwyer Manometer",			0.,		750.,	6160,	30802 },
	{ enSENSYS		, "SENSYS DPLH0750A",			0.,		750.,	6160,	30802 },
	{ enJLK_25		, "JLK 25A",					0.,		130.,	6160,	30802 },
	{ enULK_25		, "ULK 25A",					0.,		130.,	6160,	30802 },
	{ enSEBA120		, "SEBA 120",					0.,		120.,	6654,	32767 },
	{ enREG			, "",						0.,		18,		6654,	32767 },
	{ enCKD_FLOW	, "CKD FLUEREX",				0.,		4000.,	6160,	30802 },
	{ enPT100OHM	, "PT 100 OHM",					0.,		4000.,	6160,	30802 },
	{ enLEVEL_GAGE	, "LOAD CELL SENSYS PSH(0.1kgf/cm2)",	0.,		1000.,	6160,	30802 }	
};


CDlgSelSensor::CDlgSelSensor(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSelSensor::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSelSensor)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgSelSensor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSelSensor)
	DDX_Control(pDX, IDC_LIST_SENSOR, m_lbSensorType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgSelSensor, CDialog)
	//{{AFX_MSG_MAP(CDlgSelSensor)
	ON_LBN_SELCHANGE(IDC_LIST_SENSOR, OnSelchangeListSensor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSelSensor message handlers

BOOL CDlgSelSensor::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_nNo = 0;

	MAC_COLOR_SET color;
	m_macOk.GetColorSetting( &color );
	color.crFace = LIGHT_GREEN_COLOR;
	color.crLiteShadow = MAGENTA_COLOR;
	m_macOk.SetColorSetting( color );
	//m_macOk.SetBold();
	
	// TODO: Add extra initialization here
	for( int i = 0 ; i < enMAX_SENSOR_TYPE ; i ++ )
	{
		m_lbSensorType.AddString( (LPCTSTR) m_aiPreSet[i].sName );
	}
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgSelSensor::OnSelchangeListSensor() 
{
	// TODO: Add your control notification handler code here
	m_nNo = m_lbSensorType.GetCurSel();
}

void CDlgSelSensor::OnOK() 
{
	// TODO: Add extra validation here
	((CDlgCalibration*)m_pParentWnd)->DefaultSetting( m_nNo );	
	CDialog::OnOK();
}

BOOL CDlgSelSensor::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	m_pParentWnd = pParentWnd;
	return CDialog::Create(IDD, pParentWnd);
}

