 // RegistryLikeData.cpp: implementation of the CIniData class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "IniData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CIniData::CIniData()
{
	m_sFileName.Empty();
	m_File.m_hFile = NULL;

	m_pSectionList = NULL;
	m_pKeyList = NULL;

	m_pSectionList = new CStringList();
	m_pKeyList = new CStringList();
}

CIniData::CIniData( CString sFileName, CString sLocalDirName )
{
	m_pSectionList = NULL;
	m_pKeyList = NULL;

	m_pSectionList = new CStringList();
	m_pKeyList = new CStringList();

	m_sFileName = sFileName;
	char lpBuffer[1000];
	GetCurrentDirectory( 1000, lpBuffer );

	if( sLocalDirName.GetLength() > 0 )
	{
		CString sPath;
		sPath.Format( "%s\\", sLocalDirName );
		CreateDirectory( sPath, NULL );
		
		sLocalDirName = sLocalDirName + "\\";
	}

	m_sFileName = CString( lpBuffer ) + "\\" + sLocalDirName + m_sFileName +".ini";

	if( !m_File.Open( m_sFileName, CFile::modeReadWrite | CFile::shareDenyNone ) ) 
	{
		m_File.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
	}
	CloseIniFile();
}

CIniData::~CIniData()
{
	if( m_pSectionList ) delete m_pSectionList;
	if( m_pKeyList ) delete m_pKeyList;
}

BOOL CIniData::Open(CString sFileName, CString sLocalDirName)
{
	m_sFileName = sFileName;
	char lpBuffer[1000];
	GetCurrentDirectory( 1000, lpBuffer );

	if( sLocalDirName.GetLength() > 0 )
	{
		CString sPath;
		sPath.Format( "D:\\DICS\\%s\\", sLocalDirName );
		CreateDirectory( sPath, NULL );
		
		sLocalDirName = sLocalDirName + "\\";
	}

//	m_sFileName = CString( lpBuffer ) + "\\" + sLocalDirName + m_sFileName +".ini";

	m_sFileName = "D:\\DICS\\" + sLocalDirName + m_sFileName +".ini";

	if( !m_File.Open( m_sFileName, CFile::modeReadWrite | CFile::shareDenyNone ) ) 
	{
		m_File.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
	}
	CloseIniFile();

	return TRUE;
}
CStringList* CIniData::GetSectionList()
{
	char ac_Result[2000];
	m_pSectionList->RemoveAll();
	
	long lRv = GetPrivateProfileSectionNames( ac_Result, 2000, (LPCTSTR)m_sFileName );
	
	CString strSectionName;
	for( int i = 0 ; i < lRv ; i ++ )
	{
		if(ac_Result[i] != '\0') 
		{
			strSectionName = strSectionName + ac_Result[i];
		} 
		else 
		{
			if( strSectionName != "" ) 
			{
				m_pSectionList->InsertAfter( m_pSectionList->GetTailPosition(), strSectionName );
			}
			strSectionName = "";
		}
	}
	return m_pSectionList;
}

CStringList* CIniData::GetKeyList( LPCTSTR sSectionName )
{
	char ac_Result[10000];  //change size depending on needs
	m_pKeyList->RemoveAll();
	long lRv = GetPrivateProfileSection( (LPCTSTR)sSectionName, ac_Result, 10000, (LPCTSTR)m_sFileName );

	CString strSectionData;
	for( int i = 0 ; i < lRv ; i ++ )
	{
		if( ac_Result[i] != '\0' ) 
		{
			strSectionData = strSectionData + ac_Result[i];
		} 
		else 
		{
			if( strSectionData != "" ) 
			{
				m_pKeyList->InsertAfter( m_pKeyList->GetTailPosition(), strSectionData );
			}
			strSectionData = "";
		}
	}
	return m_pKeyList;
}

int CIniData::GetIntValue(LPCTSTR sSectionName, LPCTSTR sKeyName, int nDefaultValue)
{
	int nRv;
	CString sValue;

	nRv = GetPrivateProfileInt( sSectionName, sKeyName, nDefaultValue, m_sFileName );
	return nRv;
}

CString CIniData::GetStringValue(LPCTSTR sSectionName, LPCTSTR sKeyName, LPCTSTR sDefaultValue)
{
	CString sValue;
	char lpszValue[255];

	DWORD dwRv = GetPrivateProfileString( sSectionName, sKeyName, sDefaultValue, lpszValue, 255, m_sFileName );

	if( dwRv == -1 ) return sDefaultValue;
	else 
	{
		sValue = CString( lpszValue );
		return sValue;
	}

}

BOOL CIniData::SetIntValue(LPCTSTR sSectionName, LPCTSTR sKeyName, int nValue, BOOL bForceWrite)
{
	CString sValue;
	sValue.Format( "%d", nValue );

	DWORD dwRv = GetPrivateProfileInt( sSectionName, sKeyName, 100, (LPCTSTR)m_sFileName );

	if( dwRv == -1 && !bForceWrite ) // Can't Find any Matching Section Key
	{
		return FALSE;
	}
	else 
	{
		if( WritePrivateProfileString( sSectionName, sKeyName, (LPCTSTR)sValue, m_sFileName ) == 0 )
			return FALSE;
	}

	return TRUE;
}


BOOL CIniData::SetStringValue(LPCTSTR sSectionName, LPCTSTR sKeyName, LPCTSTR sValue, BOOL bForceWrite)
{
	char lpszValue[255];
	wsprintf( lpszValue, "%s", sValue );
	DWORD dwRv = GetPrivateProfileString( sSectionName, sKeyName, " ", lpszValue, 255, m_sFileName );

	if( dwRv == 0 && !bForceWrite ) // Can't Find any Matching Section Key
	{
		return FALSE;
	}
	else 
	{
		if( WritePrivateProfileString( sSectionName, sKeyName, (LPCTSTR)sValue, m_sFileName ) == 0 )
			return FALSE;
	}

	return TRUE;
}

void CIniData::CloseIniFile()
{
	try
	{
		if( m_File.m_hFile != (UINT)m_File.hFileNull ) 
		{
			m_File.Close();
		}
	}
	catch( CFileException* pEX )
	{
		pEX->Delete();
	}
}

